# flavius.spec
# Specification algebrique de la liste de Flavius
# Auteur : VOURIOT Thierry
# Date : 27 novembre 2001

spec LISTE_FLAVIUS etend LISTE1(BASE avec S -> Nat)

	operations

		constl40: -> Liste	#Construction d'une liste d'entiers de 1 a 40
		decag6: Liste -> Liste	#Effectue 6 fois un decalage a gauche
		flavius: -> Nat		#Renvoie le nombre de Flavius


	preconditions 

		pre deca6g(l) = lgr(l) >= 2		


	axiomes 

		constl40 = l
			avec (i,l) = init(1,listenouv)
			tantque i<41 rep (i+1,adjq(l,i)) frep

		decag6(l) = lres
			avec (i,lres) = init(1,l)
			tantque i<7 rep (i+1,decg(lres)) frep

		flavius = tete(l)
			avec (i,l) = init(1,constl40)
			tantque i<=39 rep (i+1,suppt(decag6(l))) frep

fspec
